const int16_t twd_lut_4[][2] = {
    {16384, 0},
    {0, -16384},
};
const int16_t twd_lut_8[][2] = {
    {16384, 0},
    {11585, -11585},
    {0, -16384},
    {-11585, -11585},
};
const int16_t twd_lut_16[][2] = {
    {16384, 0},  {15136, -6269},  {11585, -11585},  {6269, -15136},
    {0, -16384}, {-6269, -15136}, {-11585, -11585}, {-15136, -6269},
};
const int16_t twd_lut_32[][2] = {
    {16384, 0},       {16069, -3196},  {15136, -6269},  {13622, -9102},
    {11585, -11585},  {9102, -13622},  {6269, -15136},  {3196, -16069},
    {0, -16384},      {-3196, -16069}, {-6269, -15136}, {-9102, -13622},
    {-11585, -11585}, {-13622, -9102}, {-15136, -6269}, {-16069, -3196},
};
const int16_t twd_lut_64[][2] = {
    {16384, 0},       {16305, -1605},   {16069, -3196},  {15678, -4756},
    {15136, -6269},   {14449, -7723},   {13622, -9102},  {12665, -10393},
    {11585, -11585},  {10393, -12665},  {9102, -13622},  {7723, -14449},
    {6269, -15136},   {4756, -15678},   {3196, -16069},  {1605, -16305},
    {0, -16384},      {-1605, -16305},  {-3196, -16069}, {-4756, -15678},
    {-6269, -15136},  {-7723, -14449},  {-9102, -13622}, {-10393, -12665},
    {-11585, -11585}, {-12665, -10393}, {-13622, -9102}, {-14449, -7723},
    {-15136, -6269},  {-15678, -4756},  {-16069, -3196}, {-16305, -1605},
};
const int16_t twd_lut_128[][2] = {
    {16384, 0},       {16364, -803},    {16305, -1605},   {16206, -2404},
    {16069, -3196},   {15892, -3980},   {15678, -4756},   {15426, -5519},
    {15136, -6269},   {14810, -7005},   {14449, -7723},   {14053, -8423},
    {13622, -9102},   {13159, -9759},   {12665, -10393},  {12139, -11002},
    {11585, -11585},  {11002, -12139},  {10393, -12665},  {9759, -13159},
    {9102, -13622},   {8423, -14053},   {7723, -14449},   {7005, -14810},
    {6269, -15136},   {5519, -15426},   {4756, -15678},   {3980, -15892},
    {3196, -16069},   {2404, -16206},   {1605, -16305},   {803, -16364},
    {0, -16384},      {-803, -16364},   {-1605, -16305},  {-2404, -16206},
    {-3196, -16069},  {-3980, -15892},  {-4756, -15678},  {-5519, -15426},
    {-6269, -15136},  {-7005, -14810},  {-7723, -14449},  {-8423, -14053},
    {-9102, -13622},  {-9759, -13159},  {-10393, -12665}, {-11002, -12139},
    {-11585, -11585}, {-12139, -11002}, {-12665, -10393}, {-13159, -9759},
    {-13622, -9102},  {-14053, -8423},  {-14449, -7723},  {-14810, -7005},
    {-15136, -6269},  {-15426, -5519},  {-15678, -4756},  {-15892, -3980},
    {-16069, -3196},  {-16206, -2404},  {-16305, -1605},  {-16364, -803},
};
const int16_t twd_lut_256[][2] = {
    {16384, 0},       {16379, -402},    {16364, -803},    {16339, -1205},
    {16305, -1605},   {16260, -2005},   {16206, -2404},   {16142, -2801},
    {16069, -3196},   {15985, -3589},   {15892, -3980},   {15790, -4369},
    {15678, -4756},   {15557, -5139},   {15426, -5519},   {15286, -5896},
    {15136, -6269},   {14978, -6639},   {14810, -7005},   {14634, -7366},
    {14449, -7723},   {14255, -8075},   {14053, -8423},   {13842, -8765},
    {13622, -9102},   {13395, -9434},   {13159, -9759},   {12916, -10079},
    {12665, -10393},  {12406, -10701},  {12139, -11002},  {11866, -11297},
    {11585, -11585},  {11297, -11866},  {11002, -12139},  {10701, -12406},
    {10393, -12665},  {10079, -12916},  {9759, -13159},   {9434, -13395},
    {9102, -13622},   {8765, -13842},   {8423, -14053},   {8075, -14255},
    {7723, -14449},   {7366, -14634},   {7005, -14810},   {6639, -14978},
    {6269, -15136},   {5896, -15286},   {5519, -15426},   {5139, -15557},
    {4756, -15678},   {4369, -15790},   {3980, -15892},   {3589, -15985},
    {3196, -16069},   {2801, -16142},   {2404, -16206},   {2005, -16260},
    {1605, -16305},   {1205, -16339},   {803, -16364},    {402, -16379},
    {0, -16384},      {-402, -16379},   {-803, -16364},   {-1205, -16339},
    {-1605, -16305},  {-2005, -16260},  {-2404, -16206},  {-2801, -16142},
    {-3196, -16069},  {-3589, -15985},  {-3980, -15892},  {-4369, -15790},
    {-4756, -15678},  {-5139, -15557},  {-5519, -15426},  {-5896, -15286},
    {-6269, -15136},  {-6639, -14978},  {-7005, -14810},  {-7366, -14634},
    {-7723, -14449},  {-8075, -14255},  {-8423, -14053},  {-8765, -13842},
    {-9102, -13622},  {-9434, -13395},  {-9759, -13159},  {-10079, -12916},
    {-10393, -12665}, {-10701, -12406}, {-11002, -12139}, {-11297, -11866},
    {-11585, -11585}, {-11866, -11297}, {-12139, -11002}, {-12406, -10701},
    {-12665, -10393}, {-12916, -10079}, {-13159, -9759},  {-13395, -9434},
    {-13622, -9102},  {-13842, -8765},  {-14053, -8423},  {-14255, -8075},
    {-14449, -7723},  {-14634, -7366},  {-14810, -7005},  {-14978, -6639},
    {-15136, -6269},  {-15286, -5896},  {-15426, -5519},  {-15557, -5139},
    {-15678, -4756},  {-15790, -4369},  {-15892, -3980},  {-15985, -3589},
    {-16069, -3196},  {-16142, -2801},  {-16206, -2404},  {-16260, -2005},
    {-16305, -1605},  {-16339, -1205},  {-16364, -803},   {-16379, -402},
};
const int16_t twd_lut_512[][2] = {
    {16384, 0},       {16382, -201},    {16379, -402},    {16372, -603},
    {16364, -803},    {16353, -1004},   {16339, -1205},   {16323, -1405},
    {16305, -1605},   {16284, -1805},   {16260, -2005},   {16234, -2204},
    {16206, -2404},   {16175, -2602},   {16142, -2801},   {16107, -2998},
    {16069, -3196},   {16028, -3393},   {15985, -3589},   {15940, -3785},
    {15892, -3980},   {15842, -4175},   {15790, -4369},   {15735, -4563},
    {15678, -4756},   {15618, -4948},   {15557, -5139},   {15492, -5329},
    {15426, -5519},   {15357, -5708},   {15286, -5896},   {15212, -6083},
    {15136, -6269},   {15058, -6455},   {14978, -6639},   {14895, -6822},
    {14810, -7005},   {14723, -7186},   {14634, -7366},   {14543, -7545},
    {14449, -7723},   {14353, -7900},   {14255, -8075},   {14155, -8249},
    {14053, -8423},   {13948, -8594},   {13842, -8765},   {13733, -8934},
    {13622, -9102},   {13510, -9268},   {13395, -9434},   {13278, -9597},
    {13159, -9759},   {13038, -9920},   {12916, -10079},  {12791, -10237},
    {12665, -10393},  {12536, -10548},  {12406, -10701},  {12273, -10853},
    {12139, -11002},  {12003, -11150},  {11866, -11297},  {11726, -11442},
    {11585, -11585},  {11442, -11726},  {11297, -11866},  {11150, -12003},
    {11002, -12139},  {10853, -12273},  {10701, -12406},  {10548, -12536},
    {10393, -12665},  {10237, -12791},  {10079, -12916},  {9920, -13038},
    {9759, -13159},   {9597, -13278},   {9434, -13395},   {9268, -13510},
    {9102, -13622},   {8934, -13733},   {8765, -13842},   {8594, -13948},
    {8423, -14053},   {8249, -14155},   {8075, -14255},   {7900, -14353},
    {7723, -14449},   {7545, -14543},   {7366, -14634},   {7186, -14723},
    {7005, -14810},   {6822, -14895},   {6639, -14978},   {6455, -15058},
    {6269, -15136},   {6083, -15212},   {5896, -15286},   {5708, -15357},
    {5519, -15426},   {5329, -15492},   {5139, -15557},   {4948, -15618},
    {4756, -15678},   {4563, -15735},   {4369, -15790},   {4175, -15842},
    {3980, -15892},   {3785, -15940},   {3589, -15985},   {3393, -16028},
    {3196, -16069},   {2998, -16107},   {2801, -16142},   {2602, -16175},
    {2404, -16206},   {2204, -16234},   {2005, -16260},   {1805, -16284},
    {1605, -16305},   {1405, -16323},   {1205, -16339},   {1004, -16353},
    {803, -16364},    {603, -16372},    {402, -16379},    {201, -16382},
    {0, -16384},      {-201, -16382},   {-402, -16379},   {-603, -16372},
    {-803, -16364},   {-1004, -16353},  {-1205, -16339},  {-1405, -16323},
    {-1605, -16305},  {-1805, -16284},  {-2005, -16260},  {-2204, -16234},
    {-2404, -16206},  {-2602, -16175},  {-2801, -16142},  {-2998, -16107},
    {-3196, -16069},  {-3393, -16028},  {-3589, -15985},  {-3785, -15940},
    {-3980, -15892},  {-4175, -15842},  {-4369, -15790},  {-4563, -15735},
    {-4756, -15678},  {-4948, -15618},  {-5139, -15557},  {-5329, -15492},
    {-5519, -15426},  {-5708, -15357},  {-5896, -15286},  {-6083, -15212},
    {-6269, -15136},  {-6455, -15058},  {-6639, -14978},  {-6822, -14895},
    {-7005, -14810},  {-7186, -14723},  {-7366, -14634},  {-7545, -14543},
    {-7723, -14449},  {-7900, -14353},  {-8075, -14255},  {-8249, -14155},
    {-8423, -14053},  {-8594, -13948},  {-8765, -13842},  {-8934, -13733},
    {-9102, -13622},  {-9268, -13510},  {-9434, -13395},  {-9597, -13278},
    {-9759, -13159},  {-9920, -13038},  {-10079, -12916}, {-10237, -12791},
    {-10393, -12665}, {-10548, -12536}, {-10701, -12406}, {-10853, -12273},
    {-11002, -12139}, {-11150, -12003}, {-11297, -11866}, {-11442, -11726},
    {-11585, -11585}, {-11726, -11442}, {-11866, -11297}, {-12003, -11150},
    {-12139, -11002}, {-12273, -10853}, {-12406, -10701}, {-12536, -10548},
    {-12665, -10393}, {-12791, -10237}, {-12916, -10079}, {-13038, -9920},
    {-13159, -9759},  {-13278, -9597},  {-13395, -9434},  {-13510, -9268},
    {-13622, -9102},  {-13733, -8934},  {-13842, -8765},  {-13948, -8594},
    {-14053, -8423},  {-14155, -8249},  {-14255, -8075},  {-14353, -7900},
    {-14449, -7723},  {-14543, -7545},  {-14634, -7366},  {-14723, -7186},
    {-14810, -7005},  {-14895, -6822},  {-14978, -6639},  {-15058, -6455},
    {-15136, -6269},  {-15212, -6083},  {-15286, -5896},  {-15357, -5708},
    {-15426, -5519},  {-15492, -5329},  {-15557, -5139},  {-15618, -4948},
    {-15678, -4756},  {-15735, -4563},  {-15790, -4369},  {-15842, -4175},
    {-15892, -3980},  {-15940, -3785},  {-15985, -3589},  {-16028, -3393},
    {-16069, -3196},  {-16107, -2998},  {-16142, -2801},  {-16175, -2602},
    {-16206, -2404},  {-16234, -2204},  {-16260, -2005},  {-16284, -1805},
    {-16305, -1605},  {-16323, -1405},  {-16339, -1205},  {-16353, -1004},
    {-16364, -803},   {-16372, -603},   {-16379, -402},   {-16382, -201},
};
const size_t twd_lut_max = 512;
const size_t twd_lut_frac_bits = 14;
const int16_t (*twd_lut[])[2] = {
    twd_lut_4,  twd_lut_8,   twd_lut_16,  twd_lut_32,
    twd_lut_64, twd_lut_128, twd_lut_256, twd_lut_512,
};
